{ Test suit and demo for TNamedIntegerPropEdit Property Editor.
  You should install this unit as a common component.

  A component TCompTestPE has single own published property:

    NamedIntList -- string containing a list of named integer constants,
                    separated by semicolons or commas
                    (example:  'First=11;Second=22;Third=33')

  The Property Editor for TCompTestPE.Tag -- TMyNamedIntegerPropertyEdit --
  is inherited from TNamedIntegerPropEdit with a function GetNamedValues overriden.
  This function GetNamedValues initializes the string containing the list of the
  named constants,taking a value of TCompTestPE.NamedIntList string property as
  a source.

  TCompTestPE component will be registered on 'Samples' palette page and
  TMyNamedIntegerPropEdit will be registered for a property Tag' of TCompTestPE
  component.
}

unit Testpe;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DsgnIntf, PENamInt;

type
  TCompTestPE = class(TComponent)
  private
    FNamedIntList: string;
  protected
  public
    constructor Create(AOwner: TComponent); override;
  published
    property NamedIntList: string read FNamedIntList write FNamedIntList;
  end;

type TMyNamedIntegerPropEdit = class(TNamedIntegerPropEdit)
  function GetNamedValues(Component: TComponent; PropName: string): string; override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TCompTestPE]);
  RegisterPropertyEditor(TypeInfo(Longint), TCompTestPE, 'Tag', TMyNamedIntegerPropEdit);
end;

function TMyNamedIntegerPropEdit.GetNamedValues(Component: TComponent; PropName: string): string;
begin
if Component is TCompTestPE then
  Result:=(Component as TCompTestPE).NamedIntList
else
  Result:='Min=0;Max=1000';
end;

constructor TCompTestPE.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
FNamedIntList:='First=11;Second=22;Third=33';
end;

end.
 